﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Chart;
using System.Data;

namespace MyStackedAreaChart
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            spChart.Children.Add(CreateChart());
        }

        private XamChart CreateChart()
        {
            XamChart xamChart = new XamChart();
            DataTable dt = CreateDataSource();

            xamChart.Caption = new Caption();
            xamChart.Caption.Text = "aaaaa";
            xamChart.Caption.FontSize = 20;
            xamChart.Caption.Margin = new Thickness(30, 0, 0, 10);
            xamChart.Caption.MarginType = MarginType.Auto;

            // legend
            xamChart.Legend.MarginType = MarginType.Percent;
            xamChart.Legend.Margin = new Thickness(2, 10, 80, 20);

            // add data Series
            for (int i = 0; i < dt.Columns.Count - 1; i++)
            {
                Series series = new Series();
                series.ChartType = ChartType.StackedArea;
                series.Name = dt.Columns[i].ColumnName;
                series.Stroke = Brushes.Transparent;

                for (int j = 0; j < dt.Rows.Count; j++)
                {
                    DataPoint dp = new DataPoint();
                    dp.Label = dt.Rows[j][dt.Columns.Count - 1].ToString();
                    dp.Value = Convert.ToDouble(dt.Rows[j][i]);

                    series.DataPoints.Add(dp);
                }
                xamChart.Series.Add(series);
            }

            // Y-Max
            Axis xAxis = new Axis();
            xAxis.AxisType = AxisType.PrimaryX;
            xAxis.Maximum = 100;
            xAxis.Minimum = 1;
            xAxis.Unit = 20;
            //xAxis.RangeFromZero = false;
            xAxis.AutoRange = false;
            xAxis.Label.AutoResize = false;
            xAxis.Label.Angle = 0;

            Axis yAxis = new Axis();
            yAxis.AxisType = AxisType.PrimaryY;
            yAxis.Maximum = 100;
            yAxis.Minimum = 0;
            yAxis.Unit = 20;
            yAxis.AutoRange = false;

            xamChart.Axes.Add(xAxis);
            xamChart.Axes.Add(yAxis);
            xamChart.Height = 121;
            //xamChart.Width = 500;

            // scene
            xamChart.Scene.MarginType = MarginType.Percent;
            xamChart.Scene.Margin = new Thickness(14, 2, 2, 2);
            xamChart.Background = Brushes.White;
            xamChart.Scene.UpdateLayout();

            return xamChart;
        }

        private DataPoint GetDataPoint(string lable, double value)
        {
            var dp = new DataPoint();
            dp.Label = lable;
            dp.Value = value;

            return dp;
        }

        private DataTable CreateDataSource()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("system", typeof(double));
            dt.Columns.Add("idle", typeof(double));
            dt.Columns.Add("user", typeof(double));
            dt.Columns.Add("nice", typeof(double));
            dt.Columns.Add("time", typeof(string));

            Random rd = new Random();
            for (int i = 0; i < 100; i++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = rd.Next(100);
                dr[1] = rd.Next(100);
                dr[2] = rd.Next(100);
                dr[3] = rd.Next(100);
                dr[4] = DateTime.Now.AddSeconds(2).ToString("HH:mm:ss");
                dt.Rows.Add(dr);
            }
            return dt;
        }

    }
}
